#!/usr/bin/perl -w
use strict;
use warnings;
use FindBin;

my $WEoN_folder = $FindBin::Bin;
my $WEoN_src = "$WEoN_folder/src";

use Getopt::Std;
my %options=();
$options{'r'} = "WEON_configvalues";
$options{'n'} = "RefNet";
$options{'o'} = "out";
$options{'m'} = "module_output";
use Cwd;
my $dir = cwd;
print cwd . "\n";



my $username = $ENV{LOGNAME} || $ENV{USER} || getpwuid($<);

my $flag = 0;
my $input = '';
my $output = '';
my $net = '';
my $dir_out = $options{o};
my $dir_outmod = $options{m};

my $ref_TFBS_target = "";
my $ref_miRNA_target = "";
my $PTMs_filter = "";
my $comb_PTMs_filter = "";
my $TF_expre = "";
my $miRNA_expre = "";
my $CRMs = "";
my $DNAse_hyper = "";
my $Meth = "";
my $Iso_filter = "";

my $GENEs_file = "null";
my $TFBSs_file = "null";
my $synonyms_file = "null";
my $D_region = "null";
my $case = "null";
my $miRecords_file = "null";
my $mirTarbase_file = "null";
my $Tarbase_file = "null";
my $config_PTMs = "null";
my $config_comb_PTMs = "null";
my $RPKM_file = "null";
my $CRMs_file = "null";
my $iso_file = "null";
my $D_iso = "null";
my $DNAse_file = "null";
my $Meth_file = "null";
my $porc_meth = "null";
my $score_dnase = "null";

my $x = 0;
my $x_2 = 0;


#get opts and check
getopts("stho:n:r:m:",\%options);

sub help{
	if(!defined $options{"o"} || !defined $options{"r"} ||  !defined $options{"n"} || defined $options{"h"} ||
		(!-e $options{"o"} and !-d $options{"o"}) || (!-e $options{"o"} and !-d $options{"o"}) || !-e $options{"r"} || !-e $options{"n"}){
		die "usage

		perl runit [options]
		-r 		configuration file
		-n 		reference network
				RefNet_1500_gffENCODE_chips_6.12.tsv (default)
				RefNet_2000_gffENCODE_chips_6.12.tsv
				RefNet_5000_gffENCODE_chips_6.12.tsv
		-o 		output folder (default out)
		-m		module output folder (default module_output)
		-h		help & die

		";
	}
}

my @t = keys %options;

for my $i (@t){
	print "$i\t$options{$i}\n";
}


if(defined $options{r}){
	if(-e $options{r}){
		$input = $options{r};
		print "\n";
		print "Config File loaded\n";
		print "\n";
		$flag = 1;
	}else{
		die "File does not exist, please enter the location of the config file\n";
	}
}

if(defined $options{o}){
	if(-e $options{o} and -d $options{o}){
		$dir_out = $options{o};
	}
	else{
		my $a = `mkdir $options{o}`;
		if($? != 0){
			die "ERROR:\t$a\nERROR:\t$?\n";
		}
		else{
			$dir_out = $options{o};
		}
	}
}

if(defined $options{n}){
	if(-e $options{n}){
		$net = $options{n};
		my $a = `cp $net $dir_out/out_TFBS_network.tsv`;
		if($? != 0){
			die "ERROR:\t$a\nERROR:\t$?\n";
		}
	}
	else{
		die "File does not exist, please enter the location of Reference Network\n";
	}
}

if(defined $options{m}){
	if(!-e $options{m} || !-d $options{m}){
		my $a = `mkdir $options{m}`;
		if($? != 0){
			die "ERROR:\t$a\nERROR:\t$?\n";
		}
		#~ else{
			$dir_outmod = $options{m};
		#~ }
	}
}

help();



if($flag == 1){
	open (my $fh, $input)
		or die "Could not open file '$input' $!";

	while (my $row = <$fh>) {
		chomp $row;

		open(my $configdata, '>>', 'configvalues.txt');
		print $configdata "$row\n";
		close $configdata;

		print "$row\n";

		if($row !~ "#" && length($row) != 0){

			if($row !~ '\"'){
				$row =~ s/\s//g;
			}
			my @array = split("=", $row);

			####OPTIONS####
			if($array[0] eq "ref_TFBS_target"){
				$ref_TFBS_target = $array[1];
			}
			if($array[0] eq "ref_miRNA_target"){
				$ref_miRNA_target = $array[1];
			}
			if($array[0] eq "PTMs_filter"){
				$PTMs_filter = $array[1];
			}
			if($array[0] eq "comb_PTMs_filter"){
				$comb_PTMs_filter = $array[1];
			}
			if($array[0] eq "TF_express_filter"){
				$TF_expre = $array[1];
			}
			if($array[0] eq "miRNAs_express_filter"){
				$miRNA_expre = $array[1];
			}
			if($array[0] eq "CRMs"){
				$CRMs = $array[1];
			}
			if($array[0] eq "DNAse_hyper"){
				$DNAse_hyper = $array[1];
			}
			if($array[0] eq "Meth"){
				$Meth = $array[1];
			}
			if($array[0] eq "Iso_filter"){
				$Iso_filter = $array[1];
			}
			####LOCATION_FILES####
			if($array[0] eq "GENEs_file"){
				if(scalar @array > 1){
					$GENEs_file = $array[1];
				}
			}
			if($array[0] eq "TFBSs_file"){
				if(scalar @array > 1){
					$TFBSs_file = $array[1];
				}
			}
			if($array[0] eq "synonyms_file"){
				if(scalar @array > 1){
					$synonyms_file = $array[1];
				}
			}
			if($array[0] eq "D_region"){
				if(scalar @array > 1){
					$D_region = $array[1];
				}
			}
			if($array[0] eq "case"){
				if(scalar @array > 1){
					$case = $array[1];
				}
			}
			if($array[0] eq "miRecords_file"){
				if(scalar @array > 1){
					$miRecords_file = $array[1];
				}
			}
			if($array[0] eq "mirTarbase_file"){
				if(scalar @array > 1){
					$mirTarbase_file = $array[1];
				}
			}
			if($array[0] eq "Tarbase_file"){
				if(scalar @array > 1){
					$Tarbase_file = $array[1];
				}
			}
			if($array[0] eq "config_PTMs"){
				$x = 1;

				if(scalar @array > 1){
					$config_PTMs = $array[1];
					open FILE_1 ,">$config_PTMs";
				}
			}
			if($array[0] eq "config_comb_PTMs"){
			 	if($x != 0){
			 		$x = 0;
			 		close FILE_1;
			 	}
			 	$x_2 = 1;
			 	if(scalar @array > 1){
			 		$config_comb_PTMs = $array[1];
			 		open FILE_2 ,">$config_comb_PTMs";
			 	}
			 }
			if($array[0] eq "RPKM_file"){
				if($x !=0){
					$x=0;
					close FILE_1;
				}
				if($x_2 != 0){
					$x_2 = 0;
					close FILE_2;

				}
				if(scalar @array > 1){
					$RPKM_file = $array[1];
				}
			}
			if($array[0] eq "CRMs_file"){
				if(scalar @array > 1){
					$CRMs_file = $array[1];
				}
			}
			if($array[0] eq "iso_file"){
				if(scalar @array > 1){
					$iso_file = $array[1];
				}
			}
			if($array[0] eq "D_iso"){
				if(scalar @array > 1){
					$D_iso = $array[1];
				}
			}
			if($array[0] eq "DNAse_file"){
				if(scalar @array > 1){
					$DNAse_file = $array[1];
				}
			}
			if($array[0] eq "Meth_file"){
				if(scalar @array > 1){
					$Meth_file = $array[1];
				}
			}
			if($array[0] eq "porc_meth"){
				if(scalar @array > 1){
					$porc_meth = $array[1];
				}
			}

			if($array[0] eq "score_dnase"){
				if(scalar @array > 1){
					$score_dnase = $array[1];
				}
			}

			if($x == 1 && $PTMs_filter eq "Y" && $row !~ "config_PTMs"){
				$row =~ s/\"//;
				$row =~ s/\"//;
				my @aux = split (",", $row);
				for(my $i=0; $i<scalar @aux; $i++){
					print FILE_1 "$aux[$i]\n";
				}
			}
			if($x_2 == 1 && $comb_PTMs_filter eq "Y" && $row !~ "config_comb_PTMs"){
				$row =~ s/\"//;
				$row =~ s/\"//;
				my @aux = split (",", $row);
				for(my $i=0; $i<scalar @aux; $i++){
					print FILE_2 "$aux[$i]\n";
				}
			}




		}

	}
}

my $exit = 0;



if($PTMs_filter eq "Y"){
	if(-e $config_PTMs){
	}else{
		print "config_PTMs file does not exist, please enter the location in the config file\n";
		$exit = 1;
	}
}

if($comb_PTMs_filter eq "Y"){
	if(-e $config_comb_PTMs){
	}else{
		print "config_comb_PTMs file does not exist, please enter the location in the config file\n";
		$exit = 1;
	}
}


if($Meth eq "Y"){
	if(-e $Meth_file){
	}else{
		print "Meth file does not exist, please enter the location in the config file\n";
		$exit = 1;
	}
	if($porc_meth !~ /^[+-]?\d+$/){
		print "The porc_meth is not numeric, please check the config file\n";
		$exit = 1;
	}
}

if($DNAse_hyper eq "Y"){
	if(-e $DNAse_file){
	}else{
		print "DNAse file does not exist, please enter the location in the config file\n";
		$exit = 1;
	}
	if($score_dnase !~ /^[+-]?\d+$/){
		print "The score_dnase is not numeric, please check the config file\n";
		$exit = 1;
	}
}


if($exit == 1){
	system (exit);
}

my $ref_net;
if($CRMs eq "Y"){
	$ref_net = "$dir_out/TFBSs_CRMs_network.tsv";
}else{
	$ref_net = "$dir_out/out_TFBS_network.tsv";
}
if($Meth eq "Y"){
	# if($ref_TFBS_target eq "Y" || $CRMs eq "Y"){
		print "\n============DNA METHYLATION ANALYSIS============\n\n";
		my $a = `perl $WEoN_src/DNAse.pl $ref_net $Meth_file $porc_meth 2 $dir_outmod`;
		print "perl DNAse.pl $ref_net $Meth_file $porc_meth 2 $dir_outmod\n";
		print $a;
		if($? != 0){
			die "$a\n";
		}
		print "DONE!\n";

}

if($DNAse_hyper eq "Y"){
	# if($ref_TFBS_target eq "Y" || $CRMs eq "Y"){
		print "\n============DNAse I HYPERSENSITIVE ANALYSIS============\n\n";
		my $a = `perl $WEoN_src/DNAse.pl $ref_net $DNAse_file $score_dnase 1 $dir_outmod`;
		print "perl DNAse.pl $ref_net $DNAse_file $score_dnase 1 $dir_outmod\n";
		print $a;
		if($? != 0){
			die "$a\n";
		}
		print "DONE!\n";

}


my $PTMs_analysis = 0;
my $exp_ptms;

if($PTMs_filter eq "Y"){
	print "\n============PTMs-FILTER============\n\n";
	open(my $fh, '<:encoding(UTF-8)', $config_PTMs) #se abre el archivo a analizar
	  or die "Could not open file '$config_PTMs' $!";

	while (my $row = <$fh>) { #lectura del archivo linea por linea
		chomp $row;

		my @split_row = split("\t",$row);
		$exp_ptms .= "$split_row[3] ";
	}
	
	my $z = `perl $WEoN_src/Ref2TFBS_2.pl $net $WEoN_src`;
	print "perl Ref2TFBS_2.pl $net $WEoN_src\n";
	print $z;
	if($? != 0){
		die "$z";
	}


	my $a = `perl $WEoN_src/filtro_PTMs_new.pl $config_PTMs $WEoN_src/TFBS_ref_net_2.gff $GENEs_file $dir_out $dir_outmod $exp_ptms `;
	print "perl filtro_PTMs_new.pl $config_PTMs $WEoN_src/TFBS_ref_net_2.gff $GENEs_file $dir_out $dir_outmod $exp_ptms\n";
	print $a;
	if($? != 0){
		die "$a\n";
	}



	##Codigo nuevo.
	my $b = `perl $WEoN_src/conexiones_v3.pl $ref_net $dir_out/output_filter_PTMs_v2.txt $dir_out $dir_outmod`;
	print "perl conexiones_v3.pl $ref_net $dir_out/output_filter_PTMs_v2.txt $dir_out $dir_outmod\n";
	print $b;
	if($? != 0){
		die "$b";
	}

	print "DONE!\n";
	$PTMs_analysis++;
}

if($PTMs_filter eq "Y" && $comb_PTMs_filter eq "Y"){
	print "\n============COMB PTMs-FILTER============\n\n";
	print "$config_comb_PTMs\n";
	my $a = `perl $WEoN_src/script_comb_ptms.pl $config_comb_PTMs $dir_out/output_connect.txt $dir_out`;
	print "perl script_comb_ptms.pl $config_comb_PTMs $dir_out/output_connect.txt $dir_out\n"; ##No tengo idea de que hace. Añade un asterisco?
	print $a;
	if($? != 0){
		die "$a\n";
	}
	print "DONE!\n";
	$PTMs_analysis++;
}

##De la salida de este archivo, output_connect, output_connect_filter y output_comb_ptms tienen lo mismo.

if($PTMs_analysis == 1){
	print "\n============CONNECTION ANALYSIS============\n\n";
	my $a = `perl $WEoN_src/analisis_conexiones.pl $dir_out/output_connect.txt $PTMs_analysis $dir_out`;
	print "perl analisis_conexiones.pl $dir_out/output_connect.txt $PTMs_analysis $dir_out\n";
	print $a;
	if($? != 0){
		die "$a\n";
	}

	##Extra module goes here.
	print "\n============FILLING EXTRA INFO============\n\n";
	$a = `perl $WEoN_src/extra_info.pl $dir_outmod/output_connect_filter.txt $dir_out/output_connection_analysis.tsv $dir_outmod`;
	print "perl extra_info.pl $dir_outmod/output_connect_filter.txt $dir_out/output_connection_analysis.tsv $dir_outmod\n";
	print $a;
	if($? != 0){
		die "$a\n";
	}

}elsif($PTMs_analysis == 2){
	print "\n============CONNECTION ANALYSIS============\n\n";
	my $a = `perl $WEoN_src/analisis_conexiones.pl $dir_out/output_comb_ptms.txt $PTMs_analysis $dir_out`;
	print "perl analisis_conexiones.pl $dir_out/output_comb_ptms.txt $PTMs_analysis $dir_out\n";
	print $a;
	if($? != 0){
		die "$a\n";
	}

	##Extra module goes here.
	print "\n============FILLING EXTRA INFO============\n\n";
	$a = `perl $WEoN_src/extra_info.pl $dir_outmod/output_connect_filter.txt $dir_out/output_connection_analysis.tsv $dir_outmod`;
	print "perl extra_info.pl $dir_outmod/output_connect_filter.txt $dir_out/output_connection_analysis.tsv $dir_outmod\n";
	print $a;
	if($? != 0){
		die "$a\n";
	}

}

if($TF_expre eq "Y"){
		if($PTMs_filter eq "Y"){
			print "\n============REGULATOR EXPRESSION ANALYSIS============\n\n";
			print "perl expresion_reguladores.pl $RPKM_file $dir_out/output_connection_analysis.tsv $dir_out\n";
			my $a = `perl $WEoN_src/expresion_reguladores.pl $RPKM_file $dir_out/output_connection_analysis.tsv $dir_out`;
			if($? != 0){
				die "$a\n";
			}
			print "perl expresion_reguladores_v2.pl $RPKM_file $dir_outmod/output_connection_analysis_filter.tsv 1 $dir_outmod\n";
			$a = `perl $WEoN_src/expresion_reguladores_v2.pl $RPKM_file $dir_outmod/output_connection_analysis_filter.tsv 1 $dir_outmod`;
			if($? != 0){
				die "$a\n";
			}

		}else{
			print "\n============REGULATOR EXPRESSION ANALYSIS============\n\n";
			print "perl expresion_reguladores.pl $RPKM_file $ref_net $dir_out\n";
			my $a = `perl $WEoN_src/expresion_reguladores.pl $RPKM_file $ref_net $dir_out`;
			if($? != 0){
				die "$a\n";
			}
			print "perl expresion_reguladores_v2.pl $RPKM_file $ref_net $dir_outmod\n";
			$a = `perl $WEoN_src/expresion_reguladores_v2.pl $RPKM_file $ref_net 0 $dir_outmod`;
			if($? != 0){
				die "$a\n";
			}
		}
		print "DONE!\n";
}

if($miRNA_expre eq "Y"){
		print "\n============miRNAs EXPRESSION ANALYSIS============\n\n";
		print "perl expresion_reguladores_microRNA.pl $RPKM_file out_microRNA_network.tsv $dir_out\n";
		my $a = `perl $WEoN_src/expresion_reguladores_microRNA.pl $RPKM_file $WEoN_folder/example_data/out_microRNA_network.tsv $dir_out`;
		if($? != 0){
			die "$a\n";
		}
		print "DONE!\n";

}

if($TF_expre eq "Y" && $miRNA_expre eq "Y"){
	system ("cat $dir_out/output_regulator_expres.tsv $dir_out/output_miRNA_expres.tsv > $dir_out/specific_GRN.tsv");
	system ("cat $dir_outmod/output_regulator_expres_v2.tsv $dir_out/output_miRNA_expres.tsv > $dir_outmod/specific_GRN_v2.tsv");

	system ("cat $dir_out/output_regulator_no_expres.tsv $dir_out/output_miRNA_no_expres.tsv > $dir_out/filtered_expression.tsv");
	system ("cat $dir_outmod/output_regulator_no_expres_v2.tsv $dir_out/output_miRNA_no_expres.tsv > $dir_outmod/filtered_expression_v2.tsv");

}elsif($TF_expre eq "Y" && $miRNA_expre ne "Y"){
	system ("mv $dir_out/output_regulator_expres.tsv $dir_outmod/specific_GRN_v2.tsv");
	system ("mv $dir_outmod/output_regulator_expres_v2.tsv");
}elsif($miRNA_expre eq "Y" && $TF_expre ne "Y"){
	system ("mv $dir_out/output_miRNA_expres.tsv $dir_out/specific_GRN.tsv");
	system ("mv $dir_out/output_miRNA_expres.tsv $dir_outmod/specific_GRN_v2.tsv");
}


print "\n============SCORING MODULE============\n\n";
print "perl scoring.pl $dir_outmod/specific_GRN_v2.tsv $dir_out\n";
my $a = `perl $WEoN_src/scoring.pl $dir_outmod/specific_GRN_v2.tsv $dir_out`;
if($? != 0){
	die "$a\n";
}
print "DONE!\n";

system("rm -r $dir_outmod");
system("rm $WEoN_src/TFBS_ref_net_2.gff")
